[![npm](https://img.shields.io/npm/v/@highlight-ui/tag)](https://www.npmjs.com/package/@highlight-ui/tag)
[![personio.design](https://img.shields.io/static/v1?label=Personio&message=zeroheight&color=yellow)](https://www.personio.design/40d648a47/v/0/p/92acc5-tag/b/61d4aa)
[![storybook.personio.design](https://img.shields.io/static/v1?label=Personio&message=storybook&color=red)](https://storybook.personio.design/?path=/story/elements-tag--basic-tag)

# @highlight-ui/tag

Using npm:

```bash
npm install @highlight-ui/tag
```

Using yarn:

```bash
yarn add @highlight-ui/tag
```

Using pnpm:

```bash
pnpm install @highlight-ui/tag
```

In your (S)CSS file:

```scss
@import url('@highlight-ui/tag');
```

Once the package is installed, you can import the library:

```ts
import { Tag } from '@highlight-ui/tag';
```

## Usage

```tsx
import React from 'react';
import { Tag } from '@highlight-ui/tag';

export default function TagExample() {
  return <Tag text="Tag example" />;
}
```

## Props 📜

| Prop              | Type                        | Required | Default   | Description                                           |
| :---------------- | :-------------------------- | :------- | :-------- | :---------------------------------------------------- |
| `text`            | `string`                    | Yes      |           | The text on the tag                                   |
| `backgroundColor` | `string`                    | No       | `#DBE5EC` | The Tag's background color as hex                     |
| `color`           | `string`                    | No       |           | The Tag's text color as hex                           |
| `interaction`     | `'none', 'click', 'remove'` | No       | `none`    | Determines whether the tag is interactive.            |
| `maxWidth`        | `number`                    | No       | `200`     | The max width of the Tag                              |
| `onClick`         | `React.MouseEventHandler`   | No       |           | The callback to execute when interacting with the tag |
| `onRemove`        | `React.MouseEventHandler`   | No       |           | The callback to execute when removing the tag         |
| `className`       | `string`                    | No       |           | Allows providing a custom class name                  |

## Contributing 🖌️

Please visit [personio.design](https://www.personio.design/40d648a47/v/0/p/92acc5-tag/b/61d4aa) for usage guidelines and visual examples.

If you're interested in contributing, please visit our [contribution page](https://www.personio.design/40d648a47/v/0/p/138faf-about-the-process).
