import React from 'react';
import classnames from 'classnames';
import { parseMetadata, suffixMetadata } from '@highlight-ui/utils-commons';
import { Icon } from '@highlight-ui/icon';
import { Body } from '@highlight-ui/typography';
import compose from 'lodash/fp/compose';
import { colorTokens } from '@highlight-ui/tokens';

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function __rest(s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}
var styles = {
  "tag": "Tag-module__Lvhjl4p7__v5-1-17",
  "iconButton": "Tag-module__sOwXCk4q__v5-1-17",
  "buttonTag": "Tag-module__y1F1S6dq__v5-1-17"
};
function hexadecimalToRgb(hex) {
  var shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])$/i;
  var newHex = hex.replace(shorthandRegex, function (_, r, g, b) {
    return r + r + g + g + b + b;
  });
  var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(newHex);
  return result ? {
    r: window.parseInt(result[1], 16),
    g: window.parseInt(result[2], 16),
    b: window.parseInt(result[3], 16)
  } : null;
}
function mountRGBString(hex, opacity) {
  var _a = hexadecimalToRgb(hex) || {},
    r = _a.r,
    g = _a.g,
    b = _a.b;
  return opacity ? "rgb(" + r + ", " + g + ", " + b + ", " + opacity + ")" : "rgb(" + r + ", " + g + ", " + b + ")";
}
function getAppropriateTextColorBasedOnRGB(_a) {
  var r = _a.r,
    g = _a.g,
    b = _a.b;
  var offset = Math.round((r * 299 + g * 587 + b * 114) / 1000);
  return offset > 125 ? colorTokens['neutral-black'] : colorTokens['neutral-white'];
}
var getTextColorBasedOnBGColor = compose([getAppropriateTextColorBasedOnRGB, hexadecimalToRgb]);
function TagWithRef(_a, ref) {
  var _b;
  var text = _a.text,
    _c = _a.backgroundColor,
    backgroundColor = _c === void 0 ? '#DBE5EC' : _c,
    className = _a.className,
    color = _a.color,
    _d = _a.maxWidth,
    maxWidth = _d === void 0 ? 200 : _d,
    _e = _a.interaction,
    interaction = _e === void 0 ? 'none' : _e,
    metadata = _a.metadata,
    onClick = _a.onClick,
    onRemove = _a.onRemove,
    restProps = __rest(_a, ["text", "backgroundColor", "className", "color", "maxWidth", "interaction", "metadata", "onClick", "onRemove"]);
  var isClickable = interaction === 'click';
  var isRemovable = interaction === 'remove';
  var tag = isClickable ? 'button' : 'div';
  var htmlAttributes = isClickable ? {
    onClick: onClick,
    type: 'button'
  } : {};
  var backgroundColorRGB = "" + mountRGBString(backgroundColor, 'var(--opacity)');
  var textColor = color || getTextColorBasedOnBGColor(backgroundColor);
  var style = {
    backgroundColor: backgroundColorRGB,
    color: textColor
  };
  return /*#__PURE__*/React.createElement(tag, __assign(__assign(__assign(__assign({}, parseMetadata(metadata)), htmlAttributes), restProps), {
    className: classnames(styles.tag, (_b = {}, _b[styles.buttonTag] = isClickable, _b), className),
    ref: ref,
    style: style
  }), /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("span", {
    style: {
      maxWidth: maxWidth
    }
  }, /*#__PURE__*/React.createElement(Body, {
    variant: "strong-small",
    truncate: true
  }, text)), isRemovable && /*#__PURE__*/React.createElement("button", __assign({
    style: {
      color: textColor
    },
    className: styles.iconButton,
    type: "button",
    onClick: onRemove
  }, parseMetadata(suffixMetadata(metadata, 'remove-button'))), /*#__PURE__*/React.createElement(Icon, {
    name: "times",
    size: 10
  }))));
}
TagWithRef.displayName = 'Tag';
var Tag = /*#__PURE__*/React.forwardRef(TagWithRef);
export { Tag };
//# sourceMappingURL=index.js.map
